﻿Type=Service
Version=2.51
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
#End Region

Sub Process_Globals
	Private server As HttpServer
	Private templates As Map
	Public port As Int = 7777
	Private SQL As SQL
End Sub
Sub Service_Create
	server.Initialize("Server")
	server.Start(port)
	templates.Initialize
	Dim n As Notification
	n.Initialize
	n.Icon = "icon"
	n.SetInfo("Http Server is running", "", Main)
	Service.StartForeground(1, n)
	If SQL.IsInitialized = False Then
		SQL.Initialize(DBUtils.CopyDBFromAssets("1.db"), "1.db", False)
	End If
End Sub

Sub Service_Start (StartingIntent As Intent)
	
End Sub

Sub Server_HandleRequest (Request As ServletRequest, Response As ServletResponse)
	Try
		Log("Client: " & Request.RemoteAddress & ", Request: " & Request.RequestURI)
		Dim page As String = GetTemplate("template.html")
		Response.SetContentType("text/html")
		Dim query As String = Request.GetParameter("query")
		If query <> "" Then 'a query has been sent
			page = page.Replace("$QUERY$", query)
			Dim table As String
			Try
				table = DBUtils.ExecuteHtml(SQL, query, Null, 200, False)
			Catch
				table = LastException.Message 'There might be an error in the query.
			End Try
			page = page.Replace("$TABLE$", table)
		Else
			page = page.Replace("$QUERY$", "SELECT * FROM Students")
			page = page.Replace("$TABLE$", "")
		End If
		Response.SendString(page)
	Catch
		Response.Status = 500
		Log("Error serving request: " & LastException)
		Response.SendString("Error serving request: " & LastException)
	End Try
End Sub

Sub GetTemplate(Name As String) As String
	If templates.ContainsKey(Name) Then Return templates.Get(Name)
	Dim temp As String = File.ReadString(File.DirAssets, Name)
	templates.Put(Name, temp)
	Return temp
End Sub

Sub Service_Destroy
	server.Stop
	Service.StopForeground(1)
End Sub
